Index: branches/HTM-12.2-dev2-HHI/source/Lib/TLibDecoder/TDecSbac.cpp
===================================================================
--- branches/HTM-12.2-dev2-HHI/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 1104)
+++ branches/HTM-12.2-dev2-HHI/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 1106)
@@ -703,5 +703,9 @@
 
   TComVPS *vps           = pcCU->getPic()->getSlice(0)->getVPS();
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  Bool    bLimQtPredFlag = pcCU->getPic()->getSlice(0)->getQtPredFlag();
+#else
   Bool    bLimQtPredFlag = vps->getLimQtPredFlag(pcCU->getPic()->getSlice(0)->getLayerId());
+#endif
   TComPic *pcTexture      = pcCU->getSlice()->getTexturePic();
   Bool bDepthMapDetect    = (pcTexture != NULL);
@@ -757,5 +761,9 @@
   Bool bParsePartSize    = true;
   TComVPS *vps           = pcCU->getPic()->getSlice(0)->getVPS();
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  Bool    bLimQtPredFlag = pcCU->getPic()->getSlice(0)->getQtPredFlag();
+#else
   Bool    bLimQtPredFlag = vps->getLimQtPredFlag(pcCU->getPic()->getSlice(0)->getLayerId());
+#endif
   TComPic *pcTexture     = pcCU->getSlice()->getTexturePic();
   Bool bDepthMapDetect   = (pcTexture != NULL);
@@ -982,5 +990,9 @@
   {
 #if H_3D_DIM
+#if HHI_TOOL_PARAMETERS_I2_J0107
+    if( pcCU->getSlice()->getIntraSdcWedgeFlag() || pcCU->getSlice()->getIntraContourFlag() )
+#else
     if( pcCU->getSlice()->getVpsDepthModesFlag() || pcCU->getSlice()->getIVPFlag() )
+#endif
     {
       parseIntraDepth( pcCU, absPartIdx+partOffset*j, depth );
@@ -1124,5 +1136,9 @@
   if( uiIsDimMode )
   {
+#if HHI_TOOL_PARAMETERS_I2_J0107
+    if( pcCU->getSlice()->getIntraSdcWedgeFlag() && pcCU->getSlice()->getIntraContourFlag() )
+#else
     if( pcCU->getSlice()->getVpsDepthModesFlag() && pcCU->getSlice()->getIVPFlag() )
+#endif
     {
       m_pcTDecBinIf->decodeBin( uiSymbol, m_cDepthIntraModeSCModel.get( 0, 0, 0 ) );
@@ -1136,9 +1152,17 @@
       }
     }
+#if HHI_TOOL_PARAMETERS_I2_J0107
+    else if ( pcCU->getSlice()->getIntraSdcWedgeFlag() )
+#else
     else if ( pcCU->getSlice()->getVpsDepthModesFlag() )
+#endif
     {
       pcCU->setLumaIntraDirSubParts( DIM_OFFSET, absPartIdx, depth );
     }
+#if HHI_TOOL_PARAMETERS_I2_J0107
+    else if( pcCU->getSlice()->getIntraContourFlag() )
+#else
     else if( pcCU->getSlice()->getIVPFlag() )
+#endif
     {
       pcCU->setLumaIntraDirSubParts( ( 1+ DIM_OFFSET ), absPartIdx, depth );
@@ -2120,5 +2144,9 @@
 Void TDecSbac::parseDBBPFlag( TComDataCU* pcCU, UInt uiAbsPartIdx, UInt uiDepth )
 {
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  AOF( pcCU->getSlice()->getDepthBasedBlkPartFlag() );
+#else
   AOF( pcCU->getSlice()->getVPS()->getUseDBBP(pcCU->getSlice()->getLayerIdInVps()) );
+#endif
   AOF( !pcCU->getSlice()->getIsDepth() );
   
Index: branches/HTM-12.2-dev2-HHI/source/Lib/TLibDecoder/TDecSbac.h
===================================================================
--- branches/HTM-12.2-dev2-HHI/source/Lib/TLibDecoder/TDecSbac.h	(revision 1104)
+++ branches/HTM-12.2-dev2-HHI/source/Lib/TLibDecoder/TDecSbac.h	(revision 1106)
@@ -76,8 +76,12 @@
   Void  setBitstream              ( TComInputBitstream* p  ) { m_pcBitstream = p; m_pcTDecBinIf->init( p ); }
   Void  parseVPS                  ( TComVPS* /*pcVPS*/ ) {}
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  Void  parseSPS                  ( TComSPS* /*pcSPS*/ ) {}
+#else
 #if H_3D
   Void  parseSPS                  ( TComSPS* /*pcSPS*/ , Int /*viewIndex*/, Bool /*depthFlag*/ ) {}
 #else
   Void  parseSPS                  ( TComSPS* /*pcSPS*/ ) {}
+#endif
 #endif
 #if H_3D
Index: branches/HTM-12.2-dev2-HHI/source/Lib/TLibDecoder/TDecTop.cpp
===================================================================
--- branches/HTM-12.2-dev2-HHI/source/Lib/TLibDecoder/TDecTop.cpp	(revision 1104)
+++ branches/HTM-12.2-dev2-HHI/source/Lib/TLibDecoder/TDecTop.cpp	(revision 1106)
@@ -726,4 +726,9 @@
 
 #endif
+#if HHI_TOOL_PARAMETERS_I2_J0107
+#if H_3D
+  m_apcSlicePilot->init3dToolParameters();
+#endif
+#endif
   pps->setSPS(sps);
   pps->setNumSubstreams(pps->getEntropyCodingSyncEnabledFlag() ? ((sps->getPicHeightInLumaSamples() + sps->getMaxCUHeight() - 1) / sps->getMaxCUHeight()) * (pps->getNumTileColumnsMinus1() + 1) : 1);
@@ -1239,5 +1244,9 @@
   TComVPS* vps = m_parameterSetManagerDecoder.getPrefetchedVPS( 0 ); 
   assert( vps != 0 );
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  m_cEntropyDecoder.decodeSPS( sps );
+#else
   m_cEntropyDecoder.decodeSPS( sps, vps->getViewIndex( m_layerId ), ( vps->getDepthId( m_layerId ) == 1 ) );
+#endif
 #else
   m_cEntropyDecoder.decodeSPS( sps );
Index: branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncCavlc.cpp
===================================================================
--- branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 1104)
+++ branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 1106)
@@ -638,8 +638,12 @@
 }
 
+#if HHI_TOOL_PARAMETERS_I2_J0107
+Void TEncCavlc::codeSPS( TComSPS* pcSPS )
+#else
 #if H_3D
 Void TEncCavlc::codeSPS( TComSPS* pcSPS, Int viewIndex, Bool depthFlag )
 #else
 Void TEncCavlc::codeSPS( TComSPS* pcSPS )
+#endif
 #endif
 {
@@ -842,5 +846,9 @@
   if ( pcSPS->getSps3dExtensionFlag() )
   {
+#if HHI_TOOL_PARAMETERS_I2_J0107
+    codeSPS3dExtension( pcSPS ); 
+#else
     codeSPSExtension2( pcSPS, viewIndex, depthFlag  ); 
+#endif
   }
 
@@ -868,8 +876,38 @@
 
 #if H_3D
+#if HHI_TOOL_PARAMETERS_I2_J0107
+Void TEncCavlc::codeSPS3dExtension( TComSPS* pcSPS )
+{
+  TComSps3dExtension* sps3dExt = pcSPS->getSps3dExtension();
+  for( Int d = 0; d  <=  1; d++ )
+  {
+    WRITE_FLAG( sps3dExt->getIvMvPredFlag( d ) ? 1 : 0 , "iv_mv_pred_flag" );
+    WRITE_FLAG( sps3dExt->getIvMvScalingFlag( d ) ? 1 : 0 , "iv_mv_scaling_flag" );
+    if( d  ==  0 )
+    {
+      WRITE_UVLC( sps3dExt->getLog2SubPbSizeMinus3( d ), "log2_sub_pb_size_minus3" );
+      WRITE_FLAG( sps3dExt->getIvResPredFlag( d ) ? 1 : 0 , "iv_res_pred_flag" );
+      WRITE_FLAG( sps3dExt->getDepthRefinementFlag( d ) ? 1 : 0 , "depth_refinement_flag" );
+      WRITE_FLAG( sps3dExt->getViewSynthesisPredFlag( d ) ? 1 : 0 , "view_synthesis_pred_flag" );
+      WRITE_FLAG( sps3dExt->getDepthBasedBlkPartFlag( d ) ? 1 : 0 , "depth_based_blk_part_flag" );
+    }
+    else 
+    {
+      WRITE_FLAG( sps3dExt->getMpiFlag( d ) ? 1 : 0 , "mpi_flag" );
+      WRITE_UVLC( sps3dExt->getLog2MpiSubPbSizeMinus3( d ), "log2_mpi_sub_pb_size_minus3" );
+      WRITE_FLAG( sps3dExt->getIntraContourFlag( d ) ? 1 : 0 , "intra_contour_flag" );
+      WRITE_FLAG( sps3dExt->getIntraSdcWedgeFlag( d ) ? 1 : 0 , "intra_sdc_wedge_flag" );
+      WRITE_FLAG( sps3dExt->getQtPredFlag( d ) ? 1 : 0 , "qt_pred_flag" );
+      WRITE_FLAG( sps3dExt->getInterSdcFlag( d ) ? 1 : 0 , "inter_sdc_flag" );
+      WRITE_FLAG( sps3dExt->getIntraSingleFlag( d ) ? 1 : 0 , "intra_single_flag" );
+    }
+  }
+}
+#else
 Void TEncCavlc::codeSPSExtension2( TComSPS* pcSPS, Int viewIndex, Bool depthFlag )
 {
 
 }
+#endif
 #endif
 
@@ -1577,4 +1615,5 @@
 Void TEncCavlc::codeVPSExtension2( TComVPS* pcVPS )
 { 
+#if !HHI_TOOL_PARAMETERS_I2_J0107
   for( Int i = 1; i <= pcVPS->getMaxLayersMinus1(); i++ )
   {
@@ -1622,4 +1661,5 @@
     }  
   }
+#endif
   WRITE_UVLC( pcVPS->getCamParPrecision(), "cp_precision" );
   for (UInt viewIndex=1; viewIndex<pcVPS->getNumViews(); viewIndex++)
@@ -2088,4 +2128,7 @@
     {
 #if H_3D_IV_MERGE
+#if HHI_TOOL_PARAMETERS_I2_J0107
+      WRITE_UVLC( ( ( pcSlice->getMpiFlag( ) || pcSlice->getIvMvPredFlag( ) ) ? MRG_MAX_NUM_CANDS_MEM : MRG_MAX_NUM_CANDS ) - pcSlice->getMaxNumMergeCand(), "five_minus_max_num_merge_cand");
+#else
       if(pcSlice->getIsDepth())
       {
@@ -2099,4 +2142,5 @@
         WRITE_UVLC( ( ivMvPredFlag ? MRG_MAX_NUM_CANDS_MEM : MRG_MAX_NUM_CANDS ) - pcSlice->getMaxNumMergeCand(), "five_minus_max_num_merge_cand");
       }
+#endif
 #else
       WRITE_UVLC(MRG_MAX_NUM_CANDS - pcSlice->getMaxNumMergeCand(), "five_minus_max_num_merge_cand");
Index: branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncCavlc.h
===================================================================
--- branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncCavlc.h	(revision 1104)
+++ branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncCavlc.h	(revision 1106)
@@ -100,6 +100,11 @@
 #if H_3D
   Void  codeVPSExtension2       ( TComVPS* pcVPS ); 
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  Void  codeSPS3dExtension      ( TComSPS* pcSPS );
+  Void  codeSPS                 ( TComSPS* pcSPS );
+#else
   Void  codeSPSExtension2       ( TComSPS* pcSPS, Int viewIndex, Bool depthFlag  ); 
   Void  codeSPS                 ( TComSPS* pcSPS, Int viewIndex, Bool depthFlag );
+#endif
 #else
   Void  codeSPS                 ( TComSPS* pcSPS );
Index: branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncCfg.h
===================================================================
--- branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncCfg.h	(revision 1104)
+++ branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncCfg.h	(revision 1106)
@@ -392,4 +392,5 @@
   Double    m_dDispCoeff;
 #endif
+#if !HHI_TOOL_PARAMETERS_I2_J0107
 #if H_3D_ARP
   UInt      m_uiUseAdvResPred;
@@ -400,8 +401,10 @@
   Int      m_iSubPUMPILog2Size;
 #endif
+#endif
 #if H_3D_IC
   Bool      m_bUseIC;
   Bool      m_bUseICLowLatencyEnc;
 #endif
+#if !HHI_TOOL_PARAMETERS_I2_J0107
 #if H_3D_INTER_SDC
   bool      m_bInterSDC;
@@ -409,17 +412,23 @@
 #if H_3D_DBBP
   Bool      m_bUseDBBP;
+#endif
 #endif
   //====== Depth Intra Modes ======
 #if H_3D_DIM
   Bool      m_useDMM;
+#if !HHI_TOOL_PARAMETERS_I2_J0107
   Bool      m_useIVP;
+#endif
   Bool      m_useSDC;
   Bool      m_useDLT;
 #endif
+#if !HHI_TOOL_PARAMETERS_I2_J0107
 #if H_3D_SINGLE_DEPTH
   Bool      m_useSingleDepthMode;
 #endif
+
 #if H_3D_IV_MERGE
   Bool      m_useMPI;
+#endif
 #endif
 #if H_3D_QTLPC
@@ -497,4 +506,5 @@
   Void      setMaxTempLayer                 ( Int maxTempLayer )            { m_maxTempLayer = maxTempLayer;      }
 
+#if !HHI_TOOL_PARAMETERS_I2_J0107
 #if H_3D_ARP
   UInt       getUseAdvRP                    ( )              { return m_uiUseAdvResPred; }
@@ -510,4 +520,5 @@
   Void       setSubPUMPILog2Size            (Int u)          { m_iSubPUMPILog2Size = u;   }     
 #endif
+#endif
 #if H_3D_IC
   Void       setUseIC                       ( Bool bVal )    { m_bUseIC = bVal; }
@@ -516,4 +527,5 @@
   Bool       getUseICLowLatencyEnc          ()               { return m_bUseICLowLatencyEnc; }
 #endif
+#if !HHI_TOOL_PARAMETERS_I2_J0107
 #if H_3D_INTER_SDC
   Void       setInterSDCEnable              ( Bool bVal )    { m_bInterSDC = bVal; }
@@ -523,4 +535,5 @@
   Void       setUseDBBP                     ( Bool  b )      { m_bUseDBBP   = b; }
   Bool       getUseDBBP()                                    { return m_bUseDBBP;     }
+#endif
 #endif
   //======== Transform =============
@@ -932,4 +945,6 @@
   Void setFrameOnlyConstraintFlag(Bool b) { m_frameOnlyConstraintFlag = b; }
 #if H_3D
+
+  // Only flags that are not in the SPS3dExtension should go here. 
   /// 3D Tools 
 
@@ -976,23 +991,30 @@
   Bool      getUseDMM                       ()        { return m_useDMM; }
   Void      setUseDMM                       ( Bool b) { m_useDMM = b;    }
+#if !HHI_TOOL_PARAMETERS_I2_J0107
   Bool      getUseIVP                       ()        { return m_useIVP; }
   Void      setUseIVP                       ( Bool b) { m_useIVP = b;    }
+#endif
   Bool      getUseSDC                       ()        { return m_useSDC; }
   Void      setUseSDC                       ( Bool b) { m_useSDC = b;    }
+
   Bool      getUseDLT                       ()        { return m_useDLT; }
   Void      setUseDLT                       ( Bool b) { m_useDLT = b;    }
 #endif
+#if !HHI_TOOL_PARAMETERS_I2_J0107
 #if H_3D_SINGLE_DEPTH
   Void       setUseSingleDepthMode          ( Bool bVal )    { m_useSingleDepthMode = bVal; }
   Bool       getUseSingleDepthMode          ()               { return m_useSingleDepthMode; }
 #endif
+#endif
 #if H_3D_QTLPC
   Void      setUseQTL                       ( Bool b ) { m_bUseQTL = b;    }
   Bool      getUseQTL                       ()         { return m_bUseQTL; }
 #endif
+#if !HHI_TOOL_PARAMETERS_I2_J0107
 #if H_3D_IV_MERGE
   Void      setUseMPI                       ( Bool b ) { m_useMPI = b;    }
   Bool      getUseMPI                       ()         { return m_useMPI; }
 #endif
+#endif
 #endif // H_3D
 };
Index: branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncCu.cpp
===================================================================
--- branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncCu.cpp	(revision 1104)
+++ branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncCu.cpp	(revision 1106)
@@ -410,5 +410,9 @@
 #if H_3D_QTLPC
   TComVPS *vps            = pcPic->getSlice(0)->getVPS();
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  Bool  bLimQtPredFalg    = pcPic->getSlice(0)->getQtPredFlag(); 
+#else
   Bool  bLimQtPredFalg    = vps->getLimQtPredFlag(pcPic->getSlice(0)->getLayerId()); 
+#endif
   TComPic *pcTexture      = rpcBestCU->getSlice()->getTexturePic();
 
@@ -566,5 +570,9 @@
       {
 #if H_3D_ARP && H_3D_IV_MERGE
+#if HHI_TOOL_PARAMETERS_I2_J0107
+        if( rpcTempCU->getSlice()->getIvResPredFlag() || rpcTempCU->getSlice()->getIvMvPredFlag() )
+#else
         if( rpcTempCU->getSlice()->getVPS()->getUseAdvRP(rpcTempCU->getSlice()->getLayerId()) || rpcTempCU->getSlice()->getVPS()->getIvMvPredFlag(rpcTempCU->getSlice()->getLayerId()) )
+#endif
 #else 
 #if H_3D_ARP
@@ -590,5 +598,9 @@
 #endif 
 #if H_3D_NBDV_REF
+#if HHI_TOOL_PARAMETERS_I2_J0107
+          if( rpcTempCU->getSlice()->getDepthRefinementFlag() )
+#else
           if(rpcTempCU->getSlice()->getVPS()->getDepthRefinementFlag( rpcTempCU->getSlice()->getLayerIdInVps()))
+#endif
             DvInfo.bDV = rpcTempCU->getDisMvpCandNBDV(&DvInfo, true);
           else
@@ -673,5 +685,9 @@
 #if H_3D_DBBP
 #if SEC_DBBP_VIEW_REF_CHECK_J0037
+#if HHI_TOOL_PARAMETERS_I2_J0107
+          if( rpcTempCU->getSlice()->getDepthBasedBlkPartFlag() && rpcTempCU->getSlice()->getDefaultRefViewIdxAvailableFlag() )
+#else
           if( m_pcEncCfg->getUseDBBP() && rpcTempCU->getSlice()->getDefaultRefViewIdxAvailableFlag() )
+#endif
 #else
           if( m_pcEncCfg->getUseDBBP() )
@@ -2032,5 +2048,9 @@
           xCheckBestMode(rpcBestCU, rpcTempCU, uhDepth);
 #if H_3D_INTER_SDC
+#if HHI_TOOL_PARAMETERS_I2_J0107
+          if( rpcTempCU->getSlice()->getInterSdcFlag() && !uiNoResidual )
+#else
           if( rpcTempCU->getSlice()->getVPS()->getInterSDCFlag( rpcTempCU->getSlice()->getLayerIdInVps() ) && rpcTempCU->getSlice()->getIsDepth() && !uiNoResidual )
+#endif
           {
             Double dOffsetCost[3] = {MAX_DOUBLE,MAX_DOUBLE,MAX_DOUBLE};
@@ -2104,5 +2124,9 @@
       {
 #if H_3D_INTER_SDC
+#if HHI_TOOL_PARAMETERS_I2_J0107
+        if( rpcTempCU->getSlice()->getInterSdcFlag() )
+#else
         if( rpcTempCU->getSlice()->getVPS()->getInterSDCFlag( rpcTempCU->getSlice()->getLayerIdInVps() ) )
+#endif
         {
           bestIsSkip = !rpcBestCU->getSDCFlag( 0 ) && ( rpcBestCU->getQtRootCbf(0) == 0 );
@@ -2191,5 +2215,9 @@
   for( Int nARPW = 0; nARPW <= nARPWMax; nARPW++ )
   {
+#if HHI_TOOL_PARAMETERS_I2_J0107
+    if( !bFirstTime && rpcTempCU->getSlice()->getIvResPredFlag() )
+#else
     if( bFirstTime == false && rpcTempCU->getSlice()->getVPS()->getUseAdvRP( iLayerId ) )
+#endif
     {
       rpcTempCU->initEstData( rpcTempCU->getDepth(0), rpcTempCU->getQP(0),bTransquantBypassFlag );      
@@ -2297,5 +2325,9 @@
   xCheckBestMode(rpcBestCU, rpcTempCU, uhDepth);
 #if H_3D_INTER_SDC
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  if( rpcTempCU->getSlice()->getInterSdcFlag() && ePartSize == SIZE_2Nx2N)
+#else
   if( rpcTempCU->getSlice()->getVPS()->getInterSDCFlag( rpcTempCU->getSlice()->getLayerIdInVps() ) && rpcTempCU->getSlice()->getIsDepth() && ePartSize == SIZE_2Nx2N)
+#endif
   {
     Double dOffsetCost[3] = {MAX_DOUBLE,MAX_DOUBLE,MAX_DOUBLE};
Index: branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncEntropy.cpp
===================================================================
--- branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncEntropy.cpp	(revision 1104)
+++ branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncEntropy.cpp	(revision 1106)
@@ -78,4 +78,11 @@
 }
 
+#if HHI_TOOL_PARAMETERS_I2_J0107
+Void TEncEntropy::encodeSPS( TComSPS* pcSPS )
+{
+  m_pcEntropyCoderIf->codeSPS( pcSPS );
+  return;
+}
+#else
 #if H_3D
 Void TEncEntropy::encodeSPS( TComSPS* pcSPS, Int viewIndex, Bool depthFlag )
@@ -90,4 +97,5 @@
   return;
 }
+#endif
 #endif
 
@@ -269,5 +277,9 @@
 #if H_3D_DBBP
 #if SEC_DBBP_VIEW_REF_CHECK_J0037
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  if( pcCU->getSlice()->getDepthBasedBlkPartFlag() && (pcCU->getPartitionSize(uiAbsPartIdx) == SIZE_2NxN || pcCU->getPartitionSize(uiAbsPartIdx) == SIZE_Nx2N) && pcCU->getWidth(uiAbsPartIdx) > 8 && pcCU->getSlice()->getDefaultRefViewIdxAvailableFlag() )
+#else
   if( pcCU->getSlice()->getVPS()->getUseDBBP(pcCU->getSlice()->getLayerIdInVps()) && (pcCU->getPartitionSize(uiAbsPartIdx) == SIZE_2NxN || pcCU->getPartitionSize(uiAbsPartIdx) == SIZE_Nx2N) && pcCU->getWidth(uiAbsPartIdx) > 8 && pcCU->getSlice()->getDefaultRefViewIdxAvailableFlag() )
+#endif
 #else
   if( pcCU->getSlice()->getVPS()->getUseDBBP(pcCU->getSlice()->getLayerIdInVps()) && (pcCU->getPartitionSize(uiAbsPartIdx) == SIZE_2NxN || pcCU->getPartitionSize(uiAbsPartIdx) == SIZE_Nx2N) && pcCU->getWidth(uiAbsPartIdx) > 8 )
@@ -784,6 +796,11 @@
 Void TEncEntropy::encodeSDCFlag( TComDataCU* pcCU, UInt uiAbsPartIdx, Bool bRD )
 {
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  if( ( !pcCU->isIntra( uiAbsPartIdx ) && !pcCU->getSlice()->getInterSdcFlag() ) || 
+    ( pcCU->isIntra( uiAbsPartIdx ) && !pcCU->getSlice()->getIntraSdcWedgeFlag() ) )
+#else
   if( ( !pcCU->isIntra( uiAbsPartIdx ) && !pcCU->getSlice()->getVPS()->getInterSDCFlag( pcCU->getSlice()->getLayerIdInVps() ) ) || 
     ( pcCU->isIntra( uiAbsPartIdx ) && !pcCU->getSlice()->getVPS()->getVpsDepthModesFlag( pcCU->getSlice()->getLayerIdInVps() ) ) )
+#endif
   {
     return;
Index: branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncEntropy.h
===================================================================
--- branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncEntropy.h	(revision 1104)
+++ branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncEntropy.h	(revision 1106)
@@ -69,8 +69,12 @@
 
   virtual Void  codeVPS                 ( TComVPS* pcVPS )                                      = 0;
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  virtual Void  codeSPS                 ( TComSPS* pcSPS )                                      = 0;
+#else
 #if !H_3D
   virtual Void  codeSPS                 ( TComSPS* pcSPS )                                      = 0;
 #else
   virtual Void  codeSPS                 ( TComSPS* pcSPS, Int viewIndex, Bool depthFlag )       = 0;
+#endif
 #endif
   virtual Void  codePPS                 ( TComPPS* pcPPS )                                      = 0;
@@ -165,8 +169,12 @@
   Void encodeVPS               ( TComVPS* pcVPS);
   // SPS
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  Void encodeSPS               ( TComSPS* pcSPS );
+#else
 #if H_3D
   Void encodeSPS               ( TComSPS* pcSPS, Int viewIndex, Bool depthFlag );
 #else
   Void encodeSPS               ( TComSPS* pcSPS );
+#endif
 #endif
   Void encodePPS               ( TComPPS* pcPPS );
Index: branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncGOP.cpp
===================================================================
--- branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 1104)
+++ branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 1106)
@@ -958,4 +958,7 @@
 #endif
 #if H_3D_SINGLE_DEPTH
+#if HHI_TOOL_PARAMETERS_I2_J0107
+    pcSlice->setApplySingleDepthMode( pcSlice->getIntraSingleFlag() );
+#else
     TEncTop* pcEncTop = (TEncTop*) m_pcCfg;
     bool enableSingleDepthMode=false;
@@ -968,4 +971,5 @@
     }
     pcSlice->setApplySingleDepthMode(enableSingleDepthMode);
+#endif
 #endif    
 #if SEC_ARP_VIEW_REF_CHECK_J0037 || SEC_DBBP_VIEW_REF_CHECK_J0037
@@ -1433,8 +1437,12 @@
         pcSlice->getSPS()->getVuiParameters()->setHrdParametersPresentFlag( true );
       }
+#if HHI_TOOL_PARAMETERS_I2_J0107
+      m_pcEntropyCoder->encodeSPS(pcSlice->getSPS());
+#else
 #if !H_3D
       m_pcEntropyCoder->encodeSPS(pcSlice->getSPS());
 #else
       m_pcEntropyCoder->encodeSPS(pcSlice->getSPS(), pcSlice->getViewIndex(), pcSlice->getIsDepth() );
+#endif
 #endif
       writeRBSPTrailingBits(nalu.m_Bitstream);
Index: branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncSbac.cpp
===================================================================
--- branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncSbac.cpp	(revision 1104)
+++ branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncSbac.cpp	(revision 1106)
@@ -255,5 +255,9 @@
       curCost += m_CUTransquantBypassFlagSCModel.calcCost( curSliceType, qp, (UChar*)INIT_CU_TRANSQUANT_BYPASS_FLAG );
 #if H_3D_DIM
+#if HHI_TOOL_PARAMETERS_I2_J0107
+    if( m_pcSlice->getIntraSdcWedgeFlag() || m_pcSlice->getIntraContourFlag() )
+#else
     if( m_pcSlice->getVpsDepthModesFlag() || m_pcSlice->getIVPFlag() )
+#endif
     {
       curCost += m_cDepthIntraModeSCModel.calcCost    ( curSliceType, qp, (UChar*)INIT_DEPTH_INTRA_MODE );
@@ -346,8 +350,12 @@
 }
 
+#if HHI_TOOL_PARAMETERS_I2_J0107
+Void TEncSbac::codeSPS( TComSPS* pcSPS )
+#else
 #if H_3D
 Void TEncSbac::codeSPS( TComSPS* pcSPS, Int viewIndex, Bool depthFlag )
 #else
 Void TEncSbac::codeSPS( TComSPS* pcSPS )
+#endif
 #endif
 {
@@ -626,5 +634,9 @@
 #if H_3D_QTLPC
   TComVPS *vps           = pcCU->getPic()->getSlice(0)->getVPS();
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  Bool    bLimQtPredFlag = pcCU->getPic()->getSlice(0)->getQtPredFlag();
+#else
   Bool    bLimQtPredFlag = vps->getLimQtPredFlag(pcCU->getPic()->getSlice(0)->getLayerId());
+#endif
   TComPic *pcTexture     = pcCU->getSlice()->getTexturePic();
   Bool bDepthMapDetect   = (pcTexture != NULL);
@@ -999,5 +1011,9 @@
 
   TComVPS *vps           = pcCU->getPic()->getSlice(0)->getVPS();
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  Bool    bLimQtPredFlag = pcCU->getPic()->getSlice(0)->getQtPredFlag(); 
+#else
   Bool    bLimQtPredFlag = vps->getLimQtPredFlag(pcCU->getPic()->getSlice(0)->getLayerId());
+#endif
   TComPic *pcTexture     = pcCU->getSlice()->getTexturePic();
   Bool bDepthMapDetect   = (pcTexture != NULL);
@@ -1060,5 +1076,9 @@
     dir[j] = pcCU->getLumaIntraDir( absPartIdx+partOffset*j );
 #if H_3D_DIM
+#if HHI_TOOL_PARAMETERS_I2_J0107
+    if( pcCU->getSlice()->getIntraSdcWedgeFlag() ||  pcCU->getSlice()->getIntraContourFlag() )
+#else
     if( pcCU->getSlice()->getVpsDepthModesFlag() ||  pcCU->getSlice()->getIVPFlag() )
+#endif
     {
       codeIntraDepth( pcCU, absPartIdx+partOffset*j );
@@ -1206,5 +1226,9 @@
     }
     //mode coding
+#if HHI_TOOL_PARAMETERS_I2_J0107
+    if( pcCU->getSlice()->getIntraSdcWedgeFlag() && pcCU->getSlice()->getIntraContourFlag())
+#else
     if( pcCU->getSlice()->getVpsDepthModesFlag() && pcCU->getSlice()->getIVPFlag())
+#endif
     {
       m_pcBinIf->encodeBin( uiCodeIdx == 0 ? 0 : 1, m_cDepthIntraModeSCModel.get( 0, 0, 0 ) );
@@ -2305,5 +2329,9 @@
   PartSize ePartSize = pcCU->getPartitionSize( uiAbsPartIdx );
   AOF( ePartSize == SIZE_2NxN || ePartSize == SIZE_Nx2N );
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  AOF( pcCU->getSlice()->getDepthBasedBlkPartFlag() ); 
+#else
   AOF( pcCU->getSlice()->getVPS()->getUseDBBP(pcCU->getSlice()->getLayerIdInVps()) );
+#endif
   AOF( !pcCU->getSlice()->getIsDepth() );
   
Index: branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncSbac.h
===================================================================
--- branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncSbac.h	(revision 1104)
+++ branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncSbac.h	(revision 1106)
@@ -94,8 +94,12 @@
 
   Void  codeVPS                 ( TComVPS* pcVPS );
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  Void  codeSPS                 ( TComSPS* pcSPS     );
+#else
 #if !H_3D
   Void  codeSPS                 ( TComSPS* pcSPS     );
 #else
   Void  codeSPS                 ( TComSPS* pcSPS, Int viewIndex, Bool depthFlag );
+#endif
 #endif
   Void  codePPS                 ( TComPPS* pcPPS     );
Index: branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncSearch.cpp
===================================================================
--- branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 1104)
+++ branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 1106)
@@ -3117,10 +3117,14 @@
     }
 #endif
-
+    
 #if H_3D_DIM
     //===== determine set of depth intra modes to be tested =====
     if( m_pcEncCfg->getIsDepth() && uiWidth >= DIM_MIN_SIZE && uiWidth <= DIM_MAX_SIZE && uiWidth == uiHeight )
     {
+#if HHI_TOOL_PARAMETERS_I2_J0107
+      if( bOnlyIVP && pcCU->getSlice()->getIntraContourFlag() )
+#else
       if( bOnlyIVP && m_pcEncCfg->getUseIVP() )
+#endif
       {
         TComWedgelet* dmm4Segmentation = new TComWedgelet( uiWidth, uiHeight );
@@ -3144,5 +3148,9 @@
 
 #if H_3D_DIM_DMM
+#if HHI_TOOL_PARAMETERS_I2_J0107
+      if( ( ( m_pcEncCfg->getUseDMM() &&  pcCU->getSlice()->getIntraSdcWedgeFlag() )  || pcCU->getSlice()->getIntraContourFlag() )
+#else
       if( ( m_pcEncCfg->getUseDMM() || m_pcEncCfg->getUseIVP() )
+#endif
 #if H_3D_FAST_DEPTH_INTRA
          && (uiRdModeList[0] != PLANAR_IDX || varCU >= varThreshold)
@@ -3151,15 +3159,27 @@
       {
         UInt uiStart, uiEnd;
+#if HHI_TOOL_PARAMETERS_I2_J0107
+        if( ( m_pcEncCfg->getUseDMM() &&  pcCU->getSlice()->getIntraSdcWedgeFlag() ) &&  pcCU->getSlice()->getIntraContourFlag() )
+#else
         if( m_pcEncCfg->getUseDMM() &&  m_pcEncCfg->getUseIVP() )
+#endif
         {
           uiStart = 0;
           uiEnd   = 2;
         }
+#if HHI_TOOL_PARAMETERS_I2_J0107
+        else if( ( m_pcEncCfg->getUseDMM() &&  pcCU->getSlice()->getIntraSdcWedgeFlag() ) )
+#else
         else if( m_pcEncCfg->getUseDMM() )
+#endif
         {
           uiStart = 0;
           uiEnd   = 1;
         }
+#if HHI_TOOL_PARAMETERS_I2_J0107
+        else if( pcCU->getSlice()->getIntraContourFlag() )
+#else
         else if( m_pcEncCfg->getUseIVP() )
+#endif
         {
           uiStart = 1;
@@ -3299,5 +3319,5 @@
 #if H_3D_DIM_SDC
 #if H_3D_FAST_INTRA_SDC
-      Bool bTestSDC = ( m_pcEncCfg->getUseSDC() && pcCU->getSDCAvailable(uiPartOffset) && uiMode >= numModesForFullRD);
+      Bool bTestSDC = ( ( m_pcEncCfg->getUseSDC() &&  pcCU->getSlice()->getIntraSdcWedgeFlag() ) && pcCU->getSDCAvailable(uiPartOffset) && uiMode >= numModesForFullRD);
 #else
       Bool bTestSDC = ( m_pcEncCfg->getUseSDC() && pcCU->getSDCAvailable(uiPartOffset) );
@@ -5319,4 +5339,7 @@
 #endif
 #if H_3D_INTER_SDC
+#if HHI_TOOL_PARAMETERS_I2_J0107  
+   pcPatternKey->setSDCMRSADFlag( pcCU->getSlice()->getInterSdcFlag() );
+#else
   if ( pcCU->getSlice()->getIsDepth() && pcCU->getSlice()->getVPS()->getInterSDCFlag( pcCU->getSlice()->getLayerIdInVps() ) )
   {
@@ -5327,4 +5350,5 @@
     pcPatternKey->setSDCMRSADFlag( false );
   }
+#endif
 #endif
 
Index: branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncSlice.cpp
===================================================================
--- branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncSlice.cpp	(revision 1104)
+++ branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncSlice.cpp	(revision 1106)
@@ -215,4 +215,9 @@
   rpcSlice->setPicOutputFlag( true );
   rpcSlice->setPOC( pocCurr );
+#if HHI_TOOL_PARAMETERS_I2_J0107
+#if H_3D
+  rpcSlice->init3dToolParameters(); 
+#endif
+#endif
 #if H_3D_IC
   rpcSlice->setApplyIC( false );
@@ -608,4 +613,7 @@
   rpcSlice->setSliceSegmentArgument ( m_pcCfg->getSliceSegmentArgument() );
 #if H_3D_IV_MERGE
+#if HHI_TOOL_PARAMETERS_I2_J0107
+  rpcSlice->setMaxNumMergeCand      ( m_pcCfg->getMaxNumMergeCand()   + ( ( rpcSlice->getMpiFlag( ) || rpcSlice->getIvMvPredFlag( ) ) ? 1 : 0 ));
+#else
   if(rpcSlice->getIsDepth())
   {
@@ -616,4 +624,5 @@
     rpcSlice->setMaxNumMergeCand      ( m_pcCfg->getMaxNumMergeCand()   + ( rpcSlice->getVPS()->getIvMvPredFlag( rpcSlice->getLayerIdInVps() ) ? 1 : 0 ) );
   }
+#endif
 #else
   rpcSlice->setMaxNumMergeCand        ( m_pcCfg->getMaxNumMergeCand()        );
Index: branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncTop.cpp
===================================================================
--- branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncTop.cpp	(revision 1104)
+++ branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncTop.cpp	(revision 1106)
@@ -534,5 +534,5 @@
 Void TEncTop::encode(Bool flush, TComPicYuv* pcPicYuvOrg, TComList<TComPicYuv*>& rcListPicYuvRecOut, std::list<AccessUnit>& accessUnitsOut, Int& iNumEncoded, bool isTff, Int gopId )
 {
-  assert( 0 ); // Field coding and multiview need to be furhter harmonized. 
+  assert( 0 ); // Field coding and multiview need to be further harmonized. 
 }
 #else
Index: branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncTop.h
===================================================================
--- branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncTop.h	(revision 1104)
+++ branches/HTM-12.2-dev2-HHI/source/Lib/TLibEncoder/TEncTop.h	(revision 1106)
@@ -270,4 +270,9 @@
   Void                    setIvPicLists         ( TComPicLists* picLists) { m_ivPicLists = picLists; }
 #endif
+#if HHI_TOOL_PARAMETERS_I2_J0107
+#if H_3D
+  Void                    setSps3dExtension     ( TComSps3dExtension sps3dExtension ) { m_cSPS.setSps3dExtension( sps3dExtension );  };
+#endif
+#endif
 #if H_3D_IC
   Void                    setICEnableCandidate         ( Int* ICEnableCandidate) { m_aICEnableCandidate = ICEnableCandidate; }
Index: branches/HTM-12.2-dev2-HHI/source/Lib/TLibExtractor/TExtrTop.cpp
===================================================================
--- branches/HTM-12.2-dev2-HHI/source/Lib/TLibExtractor/TExtrTop.cpp	(revision 1104)
+++ branches/HTM-12.2-dev2-HHI/source/Lib/TLibExtractor/TExtrTop.cpp	(revision 1106)
@@ -74,5 +74,9 @@
 #if H_3D
      Int layerIdInVPS = m_cVPS.getLayerIdInVps( uiLayerId ); 
+#if HHI_TOOL_PARAMETERS_I2_J0107
+     m_cEntropyDecoder   .decodeSPS( &cSPS );
+#else
      m_cEntropyDecoder   .decodeSPS( &cSPS, m_cVPS.getViewIndex( layerIdInVPS ), ( m_cVPS.getDepthId( layerIdInVPS ) == 1 ) );
+#endif
 #else
      m_cEntropyDecoder   .decodeSPS( &cSPS );
